using System.Reflection.Emit;
using Micro.Interfaces.SymTab;

namespace Micro.Interfaces
{
    // An item stores the attributes of an operand during code generation.
    public interface IItem
    {
        // Const, Local, Static, Stack, Field, Elem, Method, Cond
        ItemKind Kind { get; set; }
        // item type
        IStruct Type { get; }
        // Const: value
        int Val { get; }
        // Arg, Local: offset
        int Adr { get; }
        // Cond: token code of relational operator
        TokenKind Relop { get; }
        // Field, Func: node from symbol table
        ISymbol Sym { get; }
        // Cond: target
        Label Label { get; }
    }
}